data_initialization;
global power_demand;
global test_production_matrix;
global interest_rate;
global electricity_price_iter;
global gas_price_iter;
global electricity_co2_emission;
global gas_co2_emission;
global heat_pump_part_load_limit
global co2_tax;
global electrical_boiler_part_load_limit;
global propane_burner_part_load_limit;
global heat_pump_improvement_with_waste_heat;
global elprice_constant;
global gasprice_constant;
global storage_priority_interval;
global max_storage_time;
global max_storage_prediction_time;
global is_running_storage_optimization;
global storage_max;
global storage_status;
global source_active;
global propane_burner_control_cost;
global heat_pump_control_cost;
heat_pump_control_cost = 0;
propane_burner_control_cost = 0;
source_active = zeros(8761,3);
storage_max = 5000*4.18*10/3600; % 5000 liters lagringstank kg*kJ/kgK*K/(s/h)
temp_power = power_demand;
is_running_storage_optimization = 0;
% for elprice_constant = 0.3:0.075:0.9
%     filename = ['OptDesignSensitivityelprice' num2str(elprice_constant*1000)];
%     for gasprice_constant = 0.2:0.05:0.6
%            filename = ['OptDesignSensitivitygasprice' num2str(gasprice_constant*1000)];
% electricity_co2_emission = 0.454/1000;
%         for co2_tax = 30:7.5:90
%               filename = ['OptDesignSensitivityElEmissionco2_tax0454' num2str(co2_tax*1000)];



% ---------------------------------------------------
% For-lkke for lagringsoptimalisering
% temp = 10^10;
% max_storage_prediction_time = 24;
% is_running_storage_optimization = 1;
% for j = 5000:5000:50000
%     storage_max = j*4.18*10/3600;
% for l = 4:24
%     max_storage_time = l;
%     for m = 1:1
%         storage_priority_interval = m;
        % -------------------------------------------------
        
        
        % Demand profile variation
        % -----------------------------
        % power_average = sum(power_demand)/8760;
        % for i = 1:8760
        %     power_demand(i,1)=power_demand(i)-(0.5*(power_demand(i)-power_average));
        % end
        % power_average = sum(power_demand)/8760;
        % for i = 1:8760
        %     power_demand(i,1)=power_demand(i)+(0.1*(power_demand(i)-power_average));
        % end
        %----------------------------------------------------------
        
        % Variasjon i varmepumpeforbedring som flge av tilknytning til spillvarme
        % ------------------------------------------------
        %  for heat_pump_improvement_with_waste_heat = 0:0.025:0.2
        %      filename = ['heat_pump_improvement_Hammerfest' num2str(1000*heat_pump_improvement_with_waste_heat)];
        
% Variasjon i reguleringskostnad
% -----------------------------------------
% for r = 0:5:300
%     propane_burner_control_cost = r;
%     filename = ['control_cost_asessment_Hammerfest' num2str(propane_burner_control_cost)];
        
        
        Qhp_max = 1204;
        Qhp_min = Qhp_max*heat_pump_part_load_limit;
        Qeb_max = 3300;
        Qeb_min = Qeb_max*electrical_boiler_part_load_limit;
        Qpb_max = 3500;
        Qpb_min = Qpb_max*propane_burner_part_load_limit;
        temp_demand = power_demand;
        if(~is_running_storage_optimization)
            max_storage_time = 24;
            max_storage_prediction_time = 24;
            storage_priority_interval = 24;
        end
        el_price = elprice_constant; % Kilde NVE
        gas_price = gasprice_constant; % Kilde NVE. Her er det lagt til 0.08 for transport og infrastruktur
        
        
        
        % Termisk energilagring
        % ------------------------------------
        storage_status = zeros(8761,2);
        heat_pump_power = Qhp_max;
        for i = 1:8760
            storage_status(i,3) = power_demand(i);
            % Control of Thermal Energy Storage
            hourly_storage_loss = 0;
            if(storage_status(i,1) > 0)
                storage_status(i+1,1) = max(0,storage_status(i,1)-storage_max*storage_loss_factor);
                hourly_storage_loss = storage_status(i,1)-storage_status(i+1,1);
            end
            if (power_demand(i) < heat_pump_power) && (storage_status(i+1,1) < storage_max) && (max(power_demand(i:min(i+max_storage_time,8760)))>heat_pump_power)
                available_storage = storage_max-storage_status(i+1,1);
                storage_status(i+1,1) = storage_status(i+1,1) + min(heat_pump_power-power_demand(i),storage_max-storage_status(i+1,1));
                storage_status(i,2) = storage_status(i+1,1) - storage_status(i,1) + hourly_storage_loss;
                power_demand(i) = power_demand(i) + min((heat_pump_power-power_demand(i)),available_storage);
            elseif ((power_demand(i) > heat_pump_power) && (storage_status(i+1,1) > 0)) && (power_demand(i) == max(power_demand(i:min(i+storage_priority_interval,8760))))
                available_stored_heat = storage_status(i+1,1);
                storage_status(i+1,1) = storage_status(i+1,1) - min(available_stored_heat,power_demand(i)-heat_pump_power);
                storage_status(i,2) = storage_status(i+1,1) - storage_status(i,1) + hourly_storage_loss;
                power_demand(i) = power_demand(i) - min(available_stored_heat,power_demand(i)-heat_pump_power);
            elseif (max(power_demand(i:min(i+max_storage_time,8760)))<=heat_pump_power)
                available_stored_heat = storage_status(i+1,1);
                storage_status(i+1,1) = storage_status(i+1,1) - available_stored_heat;
                storage_status(i,2) = storage_status(i+1,1) - available_stored_heat;
                power_demand(i) = power_demand(i) - available_stored_heat;
            end
            storage_status(i,4) = power_demand(i);
        end
        % -----------------------------------------
        
        % Effektfordeling
        % ----------------------------------------
        Qhp = zeros(8760,1);
        Qeb = zeros(8760,1);
        Qpb = zeros(8760,1);
        COP = zeros(8760,1);
        EFFeb = ones(8760,1)*0.98;
        EFFpb = zeros(8760,1);
        for i = 1:8760
            hourly_demand = power_demand(i);
            if hourly_demand >= Qhp_min
                Qhp(i) = min(hourly_demand,Qhp_max);
                hourly_demand = hourly_demand - Qhp(i);
            end
            if hourly_demand >= Qpb_min
                if ((min(hourly_demand,Qpb_max)/propane_burner_efficiency(min(hourly_demand,Qpb_max)/Qpb_max))*(gas_price + gas_co2_emission*co2_tax)+propane_burner_control_cost*(abs(source_active(i,3)-1)) + ((hourly_demand-(min(hourly_demand,Qpb_max)))/EFFeb(i))*(el_price + electricity_co2_emission*co2_tax)) < ...
                        ((((min(hourly_demand,Qeb_max))/EFFeb(i))*(el_price + electricity_co2_emission*co2_tax)) + (((hourly_demand-min(hourly_demand,Qeb_max))/propane_burner_efficiency(min(hourly_demand,Qpb_max)/Qpb_max))*(gas_price + gas_co2_emission*co2_tax)+propane_burner_control_cost*(abs(source_active(i,3)-(hourly_demand-min(hourly_demand,Qeb_max))>0))))
                    Qpb(i) = min(hourly_demand,Qpb_max);
                    Qeb(i) = hourly_demand-min(hourly_demand,Qpb_max);
                else
                    Qeb(i) = min(hourly_demand,Qeb_max);
                    Qpb(i) = hourly_demand - min(hourly_demand,Qeb_max);
                end
            else
                Qeb(i) = hourly_demand;
            end
            %     if hourly_demand > Qeb_max
            %         if hourly_demand-Qeb_max < Qpb_min
            %             Qpb(i) = Qpb_min;
            %         else
            %             Qpb(i) = min(Qpb_max,hourly_demand-Qeb_max);
            %         end
            %         hourly_demand = hourly_demand - Qpb(i);
            %     end
            %     Qeb(i) = max(hourly_demand,Qeb_min);
            
            if(Qhp_max==0)
                COP(i,1) = 1;
            else
                COP(i,1) = heat_pump_efficiency(Qhp(i)/Qhp_max)*(1+heat_pump_improvement_with_waste_heat);
            end
            if(Qpb_max==0)
                EFFpb(i,1) = 1;
            else
                EFFpb(i,1) = propane_burner_efficiency(Qpb(i)/Qpb_max);
            end
                source_active(i+1,1) = Qhp(i)>=0.01;
                source_active(i+1,2) = Qeb(i)>=0.01;
                source_active(i+1,3) = Qpb(i)>=0.01;
        end
        
        heat_pump_cycles = 0;
        propane_burner_cycles = 0;
        electrical_boiler_cycles = 0;
        
        for i = 1:8760
            k = source_active(i,:) ~= source_active(i+1,:);
            heat_pump_cycles = heat_pump_cycles + k(1);
            electrical_boiler_cycles = electrical_boiler_cycles + k(2);
            propane_burner_cycles = propane_burner_cycles + k(3);
        end
        
        heat_pump_switching_cost = heat_pump_control_cost*heat_pump_cycles;
        propane_burner_switching_cost = propane_burner_control_cost*propane_burner_cycles;
        
        
        % Operational cost of each unit
        consumption_HP = Qhp./COP;
        consumption_EB = Qeb./EFFeb;
        consumption_PB = Qpb./EFFpb;
        
        % Financial cost of each unit
        % Heat pump
        C_financial_HP = (((interest_rate*(1+interest_rate)^lifespan_HP)/((1+interest_rate)^lifespan_HP-1)) + maintenance_HP) * C_specific_HP*Qhp_max;
        
        
        % Electrical boiler
        C_financial_EB = (((interest_rate*(1+interest_rate)^lifespan_EB)/((1+interest_rate)^lifespan_EB-1)) + maintenance_EB) * C_specific_EB*Qeb_max;
        
        
        % Propane burner
        C_financial_PB = (((interest_rate*(1+interest_rate)^lifespan_PB)/((1+interest_rate)^lifespan_PB-1)) + maintenance_PB) * C_specific_PB*Qpb_max;
        
        % Total yearly energy cost
        cost = sum((el_price + electricity_co2_emission*co2_tax) * (consumption_HP + consumption_EB) + (gas_price + gas_co2_emission*co2_tax) * consumption_PB) + C_financial_HP + C_financial_EB + C_financial_PB;
        
        
        test_production_matrix(:,4) = power_demand;
        test_production_matrix(:,1) = Qhp; % Delivered heat from heat pump
        test_production_matrix(:,5) = COP; % Heat pump COP
        test_production_matrix(:,2) = Qeb; % Delivered heat from electrical boiler
        test_production_matrix(:,6) = EFFeb; % Electrical boiler efficiency
        test_production_matrix(:,3) = Qpb; % Delivered heat from gas boiler
        test_production_matrix(:,7) = EFFpb; % Gas boiler efficiency
        test_production_matrix(:,8) = el_price * (consumption_HP + consumption_EB); % Electricity cost
        test_production_matrix(:,9) = gas_price * consumption_PB; % Gas cost
        test_production_matrix(:,11) = electricity_co2_emission*co2_tax * (consumption_HP + consumption_EB); % Electricity CO2 tax
        test_production_matrix(:,10) = electricity_co2_emission*(consumption_HP + consumption_EB); % Electricity CO2 emissions
        test_production_matrix(:,13) = gas_co2_emission*co2_tax * consumption_PB; % Gas CO2 tax
        test_production_matrix(:,12) = gas_co2_emission*consumption_PB; % Gas CO2 emissions
        test_production_matrix(:,14) = (el_price + electricity_co2_emission*co2_tax) * (consumption_HP + consumption_EB) + (gas_price + gas_co2_emission*co2_tax) * consumption_PB + (heat_pump_switching_cost + propane_burner_switching_cost); % Hourly operations cost
        
        % test_production_matrix(:,1) = power_demand;
        % test_production_matrix(:,2) = Qhp; % Delivered heat from heat pump
        % test_production_matrix(:,3) = COP; % Heat pump COP
        % test_production_matrix(:,4) = Qeb; % Delivered heat from electrical boiler
        % test_production_matrix(:,5) = EFFeb; % Electrical boiler efficiency
        % test_production_matrix(:,6) = Qpb; % Delivered heat from gas boiler
        % test_production_matrix(:,7) = EFFpb; % Gas boiler efficiency
        % test_production_matrix(:,8) = el_price * (consumption_HP + consumption_EB); % Electricity cost
        % test_production_matrix(:,9) = gas_price * consumption_PB; % Gas cost
        % test_production_matrix(:,10) = (C_financial_HP + C_financial_EB + C_financial_PB)/8760; % Financial cost
        % test_production_matrix(:,11) = electricity_co2_emission*co2_tax * (consumption_HP + consumption_EB); % Electricity CO2 tax
        % test_production_matrix(:,12) = electricity_co2_emission*(consumption_HP + consumption_EB); % Electricity CO2 emissions
        % test_production_matrix(:,13) = gas_co2_emission*co2_tax * consumption_PB; % Gas CO2 tax
        % test_production_matrix(:,14) = gas_co2_emission*consumption_PB; % Gas CO2 emissions
        % test_production_matrix(:,15) = (el_price + electricity_co2_emission*co2_tax) * (consumption_HP + consumption_EB) + (gas_price + gas_co2_emission*co2_tax) * consumption_PB; % Hourly operations cost
        % test_production_matrix(:,16) = (el_price + electricity_co2_emission*co2_tax) * (consumption_HP + consumption_EB) + (gas_price + gas_co2_emission*co2_tax) * consumption_PB + test_production_matrix(:,10); % Total hourly cost
        
        %fprintf('Energy from HP: %d\tEnergy from EB: %d\tEnergy from PB: %d\n',sum(Qhp),sum(Qeb),sum(Qpb));
        power_demand = temp_demand;
%         save(filename);
%         save('filenameNotGiven');
        %--------------------------------------------------
        
%         save(['storage__size_optimizationHammerfestStorageTime' num2str(l) 'priorityInterval' num2str(m) 'storageSize' num2str(j)]);
%         if cost < temp
%             temp = cost;
%             storageTime = l;
%             priorityInterval = k;
%         end
%     end
% end
% end
% -----------------------------
% end
