data_initialization;
variable_specific_cost_and_interest;
plots_installed_capacity_varying_energy_prices;

% -----------------------------------------------------
single_variable_plots = 0;
    single_bar = 0;
    single_plot = 0;
star_plot = 1;
% -----------------------------------------------------



counter = 0;
for i = C_specific_HP_min:C_specific_HP_step:C_specific_HP_max
    load(['HP_C' num2str(i*1000)]);
    counter = counter + 1;
    y_HP_specific(counter,1:3) = p_size(1:3);
    x_HP_specific(counter) = i;
    y_op_cost_HP_specific(counter) = fval;
    x_op_cost_HP_specific(counter) = 100*(i/((C_specific_HP_max-C_specific_HP_min))-1);
end

counter = 0;
for j = C_specific_EB_min:C_specific_EB_step:C_specific_EB_max
    load(['EB_C' num2str(j*1000)]);
    counter = counter + 1;
    y_EB_specific(counter,1:3) = p_size(1:3);
    x_EB_specific(counter) = j;
    y_op_cost_EB_specific(counter) = fval;
    x_op_cost_EB_specific(counter) = 100*(j/((C_specific_EB_max-C_specific_EB_min))-1);
end

counter = 0;
for k = C_specific_PB_min:C_specific_PB_step:C_specific_PB_max
    load(['PB_C' num2str(k*1000)]);
    counter = counter + 1;
    y_PB_specific(counter,1:3) = p_size(1:3);
    x_PB_specific(counter) = k;
    y_op_cost_PB_specific(counter) = fval;
    x_op_cost_PB_specific(counter) = 100*(k/((C_specific_PB_max-C_specific_PB_min))-1);
end

counter = 0;
for l = interest_rate_min:interest_rate_step:interest_rate_max
    load(['interest' num2str(100000*l)]);
    counter = counter + 1;
    y_interest(counter,1:3) = p_size(1:3);
    x_interest(counter) = l;
    y_op_cost_interest(counter) = fval;
    x_op_cost_interest(counter) = 100*(l/((interest_rate_max-interest_rate_min))-1);
end

counter=0;
for m = co2_tax_min:co2_tax_step:co2_tax_max
    load(['co2_tax' num2str(100000*m)]);
    counter = counter + 1;
    y_co2(counter,1:3) = p_size(1:3);
    x_co2(counter) = m;
    y_op_cost_co2(counter) = fval;
    x_op_cost_co2(counter) = 100*(m/(co2_tax_mid)-1);
end

if(single_variable_plots)
    if(single_bar)
        subplot(2,3,1);
        bar(x_HP_specific,y_HP_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable heat pump specific cost')
        
        subplot(2,3,2);
        bar(x_EB_specific,y_EB_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable electrical boiler specific cost')
        
        subplot(2,3,3);
        bar(x_PB_specific,y_PB_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable propane burner specific cost')
        
        subplot(2,3,4);
        bar(x_interest,y_interest);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Interest rate [%]')
        ylabel('[kW]')
        title('Variable interest rate')
        
        subplot(2,3,5);
        bar(x_co2,y_co2);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('CO2 tax [NOK/tonne]')
        ylabel('[kW]')
        title('Variable CO2 tax')
        
    elseif(single_plot)
        subplot(2,3,1);
        plot(x_HP_specific,y_HP_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable heat pump specific cost')
        
        subplot(2,3,2);
        plot(x_EB_specific,y_EB_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable electrical boiler specific cost')
        
        subplot(2,3,3);
        plot(x_PB_specific,y_PB_specific);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Specific cost [NOK/kW]')
        ylabel('[kW]')
        title('Variable propane burner specific cost')
        
        subplot(2,3,4);
        plot(x_interest,y_interest);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('Interest rate [%]')
        ylabel('[kW]')
        title('Variable interest rate')
        
        subplot(2,3,5);
        plot(x_co2,y_co2);
        legend('Heat pump capacity [kW]','Electrical boiler capacity [kW]','Propane burner capacity [kW]');
        legend('Location','north')
        legend('boxoff')
        xlabel('CO2 tax [NOK/tonne]')
        ylabel('[kW]')
        title('Variable CO2 tax')
    end
end

if(star_plot)
    plot(x_op_cost_HP_specific,y_op_cost_HP_specific)
    hold on
    plot(x_op_cost_EB_specific,y_op_cost_EB_specific,'r')
    plot(x_op_cost_PB_specific,y_op_cost_PB_specific,'g')
    plot(x_op_cost_interest,y_op_cost_interest,'c')
    plot(x_op_cost_co2,y_op_cost_co2,'y')
    plot(-50:12.5:50,plant_matrix_cost(5,:),'Linewidth',2);
    plot(-50:12.5:50,plant_matrix_cost(:,5),'g','Linewidth',2);
    axis('tight');
    legend('HP specific cost','EB specific cost','PB specific cost','Interest rate','CO2 tax','Gas price, elprice const 0.6','El price, gas price const 0.4');
    legend('Location','north');
    legend('boxoff')
    hold off
    xlabel('Percentagewise change in variable [%]')
    ylabel('Cost of operation [NOK/year]')
end