data_initialization;
global power_demand;
global test_production_matrix;
global interest_rate;
global electricity_price_iter;
global gas_price_iter;
global electricity_co2_emission;
global gas_co2_emission;
global heat_pump_part_load_limit
global co2_tax;
global electrical_boiler_part_load_limit;
global propane_burner_part_load_limit;
global heat_pump_improvement_with_waste_heat;
global elprice_constant;
global gasprice_constant;
global storage_priority_interval;
global max_storage_time;
global max_storage_prediction_time;
global is_running_storage_optimization;
global storage_max;
global storage_status;
storage_variation_optimal_cost = zeros(24);
storage_variation_heat_pump_energy = zeros(24);
storage_variation_total_electricity_consumption = zeros(24);
storage_variation_total_gas_consumption = zeros(24);
storage_variation_total_emissions = zeros(24);
storage_variation_total_energy_delivery = zeros(24);
storage_variation_power_above_heat_pump = zeros(24);

for l = 1:24
    max_storage_time = l;
    for k = 1:24
        storage_priority_interval = k;
        load(['storage_optimizationHammerfestStorageTime' num2str(l) 'priorityInterval' num2str(k)]);
        storage_variation_optimal_cost(l,k) = cost;
        storage_variation_heat_pump_energy(l,k) = sum(test_production_matrix(:,1));
        storage_variation_total_electricity_consumption(l,k) = sum(consumption_HP + consumption_EB);
        storage_variation_total_gas_consumption(l,k) = sum(consumption_PB);
        storage_variation_total_emissions(l,k) = sum(sum(test_production_matrix(:,[10 12])));
        storage_variation_total_energy_delivery(l,k) = sum(storage_status(:,4));
        counter = 0;
        for i = 1:8760
            if storage_status(i,2) < 0
                storage_variation_power_above_heat_pump(l,k) = storage_variation_power_above_heat_pump(l,k) + storage_status(i,3);
                counter = counter + 1;
            end
        end
        storage_variation_power_above_heat_pump(l,k) = storage_variation_power_above_heat_pump(l,k)/counter;
    end
end