data_initialization;
global power_demand;
global test_production_matrix;
global interest_rate;
global electricity_price_iter;
global gas_price_iter;
global electricity_co2_emission;
global gas_co2_emission;
global heat_pump_part_load_limit
global co2_tax;
global electrical_boiler_part_load_limit;
global propane_burner_part_load_limit;
global heat_pump_improvement_with_waste_heat;
global elprice_constant;
global gasprice_constant;
global storage_priority_interval;
global max_storage_time;
global max_storage_prediction_time;
global is_running_storage_optimization;
global storage_max;
global storage_status;
storage_size_variation_optimal_cost = zeros(7,5);
storage_size_variation_heat_pump_energy = zeros(7,5);
storage_size_variation_total_electricity_consumption = zeros(7,5);
storage_size_variation_total_gas_consumption = zeros(7,5);
storage_size_variation_total_emissions = zeros(7,5);
storage_size_variation_total_energy_delivery = zeros(7,5);
for j = 5000:5000:50000
    storage_max = j*4.18*10/3600;
    for l = 4:24
        max_storage_time = l;
        for k = 1:1
            storage_priority_interval = k;
            load(['storage__size_optimizationHammerfestStorageTime' num2str(l) 'priorityInterval' num2str(k) 'storageSize' num2str(j)]);
            storage_size_variation_optimal_cost(l-3,j/5000) = cost;
            storage_size_variation_heat_pump_energy(l-3,j/5000) = sum(test_production_matrix(:,1));
            storage_size_variation_total_electricity_consumption(l-3,j/5000) = sum(consumption_HP + consumption_EB);
            storage_size_variation_total_gas_consumption(l-3,j/5000) = sum(consumption_PB);
            storage_size_variation_total_emissions(l-3,j/5000) = sum(sum(test_production_matrix(:,[10 12])));
            storage_size_variation_total_energy_delivery(l-3,j/5000) = sum(storage_status(:,4));
        end
    end
end
